class GleisIterator
{
  private GleisStueck cursor, start;
  private int accumulated, accumulated_in_gleisstueck;

  GleisIterator(GleisStueck start) { this.start = start; first(); }

  void first()
  {
    cursor = start;
    accumulated = accumulated_in_gleisstueck = 0;
  }

  void last()
  {
    accumulated = 0;

    for(cursor=start;
        cursor != null && cursor.next != null; cursor = cursor.next)
      accumulated += cursor.len;
    
    if(cursor != null)
      {
        accumulated_in_gleisstueck = cursor.len;
        accumulated += cursor.len;
      }
  }

  void next(int delta)
  {
    accumulated_in_gleisstueck += delta;

    if(delta>0)
      {
        while(cursor != null && accumulated_in_gleisstueck >= cursor.len)
          {
            accumulated_in_gleisstueck -= cursor.len;
	    accumulated += cursor.len;
	    cursor = cursor.next;
          }
      }
    else
    if(delta<0)
      {
	while(cursor != null && cursor.prev != null &&
	      accumulated_in_gleisstueck<0)
	  {
	    cursor = cursor.prev;
	    accumulated_in_gleisstueck += cursor.len;
	    accumulated -= cursor.len;
	  }

	if(cursor != null && cursor.prev == null &&
	   accumulated_in_gleisstueck<0)
	  cursor = null;
      }
  }

  boolean isDone() { return cursor == null; }

  int xkoo() { return cursor.xkoo(accumulated_in_gleisstueck); }
  int ykoo() { return cursor.ykoo(accumulated_in_gleisstueck); }
  int angle() { return cursor.angle(accumulated_in_gleisstueck); }
  int index() { if(cursor!=null) return cursor.index; else return 1000; } 
  Turtle turtle() { return cursor.turtle(accumulated_in_gleisstueck); }
}
